# checking pcr8 value and rebooting
- test:
    timeout:
      minutes: 15
      skip: false
    interactive:
    - name: measured-boot
      prompts: [".*root@(.*):[/~]#"]
      echo: discard
      script:
      - command: # wait for the prompt
      - name: check-LUKS-encryption-successful
        command: "blkid"
        successes:
        - message: "LUKS"
      - name: check-tpm-eventlog
        command: "tpm2_eventlog /sys/kernel/security/tpm0/binary_bios_measurements | grep 'Exit Boot Services Returned with Success'"
        successes:
        - message: "Exit Boot Services Returned with Success"
      - name: show-pcr8
        command: "tpm2_pcrread sha256:8"
        successes:
        - message: "sha256:"
      - command: "tpm2_pcrread sha256:8 > oPCR8.txt"
    - name: measured-boot-reboot
      echo: discard
      prompts: ["{{reboot_finished_message or "reboot: Restarting system"}}"]
      script:
      - command: "{{reboot_command or "reboot"}}"

{% if settings.LAVA_DEVICE == "rk3399-rock-pi-4b" %}
- command:
    name: hard_reset
{% endif %}

- test:
    timeout:
      minutes: 15
      skip: false
    interactive:
    - name: measured-boot
      prompts: ["Hit any key to stop autoboot", "=> "]
      script:
      - command: # wait for prompt
      - command: " " # hit a key to stop autoboot
      - command: "mw.b $loadaddr a && tpm init && tpm startup TPM2_SU_CLEAR && tpm pcr_extend 8 $loadaddr"
    - name: measured-boot-reboot
      prompts: ["Booting"]
      script:
      - command: "run bootcmd"

# wait for boot to userspace
- boot:
    timeout:
      minutes: 20
    method: minimal
    reset: false
    auto_login:
      login_prompt: 'login:'
      username: "root"
      login_commands:
        - sudo su -
    prompts:
      - .*ewaol@(.*):[/~]\$
      - .*root@(.*):[/~]#

# booting with changed pcr8 value
- test:
    timeout:
      minutes: 5
      skip: true
    interactive:
    - name: measured-boot
      prompts: [".*root@(.*):[/~]#"]
      echo: discard
      script:
      - name: show-new-pcr8
        command: "tpm2_pcrread sha256:8"
      - command: "tpm2_pcrread sha256:8 > nPCR8.txt"
    - name: measured-boot
      prompts: ["oPCR8.txt nPCR8.txt differ"]
      echo: discard
      script:
      - name: pcr8-compare
        command: cmp oPCR8.txt nPCR8.txt && echo "PCR8 has not changed"
